package Model;

import java.io.File;
import java.io.IOException;
import javax.servlet.http.HttpSession;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.xml.sax.SAXException;

/**
 *
 * @author Yannic Schnetz
 */
public abstract class Database {
    
    private DocumentBuilderFactory docFactory = null;
    private DocumentBuilder docBuilder = null;
    private Document xml = null;
    private String filename = "";
    private XPath xPath =  XPathFactory.newInstance().newXPath();
    private HttpSession session;
    
    public Database(String name, HttpSession session) throws ParserConfigurationException, SAXException, IOException, TransformerConfigurationException, TransformerException {
        this.docFactory = DocumentBuilderFactory.newInstance();
        this.docBuilder = this.docFactory.newDocumentBuilder();
        this.session = session;
        this.filename = name;

        File userdb = new File(session.getServletContext().getRealPath("") + "/xml/" + this.filename + ".xml");
        if (userdb.exists()) {
            this.xml = this.docBuilder.parse(userdb);
        } else {
            Document doc = this.docBuilder.newDocument();
            Element rootElement = doc.createElement(this.filename);
            doc.appendChild(rootElement);
            
            TransformerFactory transformerFactory = TransformerFactory.newInstance();
            Transformer transformer = transformerFactory.newTransformer();
            DOMSource source = new DOMSource(doc);
            StreamResult result = new StreamResult(new File(session.getServletContext().getRealPath("") + "/xml/" + this.filename + ".xml"));
            
            transformer.transform(source, result);
            
            this.xml = doc;
        }
    }

    public Document getXml() {
        return this.xml;
    }

    public String getFilename() {
        return filename;
    }

    public void setFilename(String filename) {
        this.filename = filename;
    }

    public XPath getxPath() {
        return xPath;
    }

    public HttpSession getSession() {
        return session;
    }
    
    public abstract Object getData(String nodeName, boolean attribute, String whereName, String whereValue);
}
