package Model;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.http.HttpServletRequest;
import javax.xml.xpath.XPathExpressionException;

/**
 *
 * @author Yannic Schnetz
 */
public class HomeModel extends Model {
    
    public HomeModel(HashMap<String, Object> attributes, Map<String, String[]> parameters, HttpServletRequest request) {
        super(attributes, parameters, request);
    }

    @Override
    public HashMap<String, Object> run() {
        try {
            ArrayList<Offer> offerList = Controller.offerDatabase.getOffers(25);
            Collections.sort(offerList);
            this.getSessionData().put("all_offers", offerList);
        } catch (XPathExpressionException ex) {
            Logger.getLogger(HomeModel.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        return this.getSessionData();
    }
}
