package Model;

import java.io.UnsupportedEncodingException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Date;

/**
 *
 * @author Yannic Schnetz
 */
public class User {

    private int id;
    private String email;
    private String password;
    private Date creationDate;

    public User() {
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public Date getCreationDate() {
        return creationDate;
    }

    public void setCreationDate(Date creationDate) {
        this.creationDate = creationDate;
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public static User createUser(String mail, String password) {
        User user = new User();
        user.setEmail(mail);
        user.setPassword(password);

        return user;
    }

    public static String decryptPassword(String pw, String email) throws NoSuchAlgorithmException, UnsupportedEncodingException {
        // PASSWORD SECURITY (MD5)
        byte[] bytesOfMessage = (pw + email).getBytes("UTF-8");

        MessageDigest md = MessageDigest.getInstance("MD5");
        byte[] hash = md.digest(bytesOfMessage);

        StringBuilder sb = new StringBuilder(2 * hash.length);

        for (byte b : hash) {
            sb.append(String.format("%02x", b & 0xff));
        }
        
        return sb.toString();
    }
}
